org.apache.ignite.internal.processors.security.os

## Class GridOsSecurityProcessor

- java.lang.Object
- - org.apache.ignite.internal.processors.GridProcessorAdapter
  - - org.apache.ignite.internal.processors.security.os.GridOsSecurityProcessor

All Implemented Interfaces:
  GridComponent, GridProcessor, GridSecurityProcessor

    public class GridOsSecurityProcessor
    extends GridProcessorAdapter
    implements GridSecurityProcessor

No-op implementation for `GridSecurityProcessor`.

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.apache.ignite.internal.GridComponent

`GridComponent.DiscoveryDataExchangeType`

### Field Summary

### Fields inherited from class org.apache.ignite.internal.processors.GridProcessorAdapter

`ctx, log`

### Constructor Summary

Constructors
Constructor and Description
`GridOsSecurityProcessor(GridKernalContext ctx)`

### Method Summary

Methods
`SecurityContext` `authenticate(AuthenticationContext authCtx)` Authenticates subject via underlying Authenticator.
`SecuritySubject` `authenticatedSubject(UUID nodeId)` Gets authenticated node subject.
`Collection<SecuritySubject>` `authenticatedSubjects()` Gets collection of authenticated nodes.
`SecurityContext` `authenticateNode(ClusterNode node, SecurityCredentials cred)` Authenticates grid node with it's attributes via underlying Authenticator.
`void` `authorize(String name, SecurityPermission perm, SecurityContext securityCtx)` Authorizes grid operation.
`boolean` `enabled()`
`boolean` `isGlobalNodeAuthentication()` Gets flag indicating whether all nodes or coordinator only should run the authentication for joining node.
`void` `onSessionExpired(UUID subjId)` Callback invoked when subject session got expired.

### Methods inherited from class org.apache.ignite.internal.processors.GridProcessorAdapter

`assertParameter, collectDiscoveryData, discoveryDataType, onDiscoveryDataReceived, onKernalStart, onKernalStop, printMemoryStats, start, stop, toString, validateNode`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.apache.ignite.internal.GridComponent

`collectDiscoveryData, discoveryDataType, onDiscoveryDataReceived, onKernalStart, onKernalStop, printMemoryStats, start, stop, validateNode`

### Constructor Detail

#### GridOsSecurityProcessor

    public GridOsSecurityProcessor(GridKernalContext ctx)

Parameters:
  `ctx` - Kernal context.

### Method Detail

#### authenticateNode

    public SecurityContext authenticateNode(ClusterNode node,
                                   SecurityCredentials cred)
                                     throws IgniteCheckedException

Authenticates grid node with it's attributes via underlying Authenticator.

Specified by:
  `authenticateNode` in interface `GridSecurityProcessor`
Parameters:
  `node` - Node id to authenticate.
  `cred` - Security credentials.
Returns:
  `True` if succeeded, `false` otherwise.
Throws:
  `IgniteCheckedException` - If error occurred.

#### isGlobalNodeAuthentication

    public boolean isGlobalNodeAuthentication()

Gets flag indicating whether all nodes or coordinator only should run the authentication for joining node.

Specified by:
  `isGlobalNodeAuthentication` in interface `GridSecurityProcessor`
Returns:
  `True` if all nodes should run authentication process, `false` otherwise.

#### authenticate

    public SecurityContext authenticate(AuthenticationContext authCtx)
                                 throws IgniteCheckedException

Authenticates subject via underlying Authenticator.

Specified by:
  `authenticate` in interface `GridSecurityProcessor`
Parameters:
  `authCtx` - Authentication context.
Returns:
  `True` if succeeded, `false` otherwise.
Throws:
  `IgniteCheckedException` - If error occurred.

#### authenticatedSubjects

    public Collection<SecuritySubject> authenticatedSubjects()

Gets collection of authenticated nodes.

Specified by:
  `authenticatedSubjects` in interface `GridSecurityProcessor`
Returns:
  Collection of authenticated nodes.

#### authenticatedSubject

    public SecuritySubject authenticatedSubject(UUID nodeId)

Gets authenticated node subject.

Specified by:
  `authenticatedSubject` in interface `GridSecurityProcessor`
Parameters:
  `nodeId` - Subject ID.
Returns:
  Security subject.

#### authorize

    public void authorize(String name,
                 SecurityPermission perm,
                 @Nullable
                 SecurityContext securityCtx)
                   throws SecurityException

Authorizes grid operation.

Specified by:
  `authorize` in interface `GridSecurityProcessor`
Parameters:
  `name` - Cache name or task class name.
  `perm` - Permission to authorize.
  `securityCtx` - Optional security context.
Throws:
  `SecurityException` - If security check failed.

#### onSessionExpired

    public void onSessionExpired(UUID subjId)

Callback invoked when subject session got expired.

Specified by:
  `onSessionExpired` in interface `GridSecurityProcessor`
Parameters:
  `subjId` - Subject ID.

#### enabled

    public boolean enabled()

Specified by:
  `enabled` in interface `GridSecurityProcessor`
Returns:
  GridSecurityProcessor is enable.

2015 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 1.3.0-incubating
Release Date | : July 10 2015